package at.xaxa.ledger.data.db

import android.content.Context
import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase
import at.xaxa.ledger.data.db.Category.CategoryEntity
import at.xaxa.ledger.data.db.Entry.EntryEntity


@Database(entities = [EntryEntity::class, CategoryEntity::class], version = 1, exportSchema = false)
abstract class LedgerDatabase : RoomDatabase() {
    abstract fun ledgerDao(): LedgerDao

    companion object {
        @Volatile
        private var Instance: LedgerDatabase? = null

        fun getDatabase(context: Context): LedgerDatabase {
            return Instance ?: synchronized(this){
                val instance =
                    Room.databaseBuilder(
                        context.applicationContext,
                        LedgerDatabase::class.java,
                        "ledger_database"
                    ).fallbackToDestructiveMigration()
                        .build()

                Instance = instance
                return instance
            }
        }
    }
}